hdu 3486(RMQ应用)

Interviewe

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2301    Accepted Submission(s): 516


Problem Description
YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is  , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?
 

Input
The input consists of multiple cases.
In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
The input ends up with two negative numbers, which should not be processed as a case.
 

Output
For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.
 

Sample Input
  
  
11 300 7 100 7 101 100 100 9 100 100 110 110 -1 -1
 

Sample Output
  
  
3
Hint
We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.
 

Source
 

Recommend
zhengfeng
 
分析:这题要求最少的区间数使得所有区间的最大值之和大于k,我们可以先用ST算法预处理每个区间的最大值,然后枚举区间个数(二分感觉会出错,不过还是可以AC的),就算和是否大于k,最小的区间数就是答案了~~~
其实这题直接二分区间数,每次都用O(n)的算法来求最值反而更快。。。不过这题二分怎么好像不靠谱呢,如果出现有一个很大的值在最后一个呢,它貌似会经常被去掉。。。
如果枚举的话,注意处理重复的求值就行了。。。
代码(ST()慢死了,判断时貌似没限制个数错了,无限wa阿):
#include<cstdio>
#define max(a,b) (a>b?a:b)
using namespace std;
const int mm=222222;
int f[mm][33];
int i,l,r,n,m,k,ans;
void ST()
{
    int i,j,k;
    for(j=1;(k=(1<<j)-1)<n;++j)
        for(i=0;i+k<n;++i)
            f[i][j]=max(f[i][j-1],f[i+(1<<(j-1))][j-1]);
}
bool ok(int len,int m)
{
    int i,j,tmp=0,c=0;
    while((1<<(c+1))<len)++c;
    for(i=j=0;j<m;i+=len,++j)
        if((tmp+=max(f[i][c],f[i+len-(1<<c)][c]))>k)return 1;
    return 0;
}
void in(int &a)
{
    char c;
    while((c=getchar())<'0'||c>'9');
    for(a=0;c>='0'&&c<='9';c=getchar())a=a*10+c-'0';
}
int main()
{
    while(scanf("%d%d",&n,&k),n>=0&&k>=0)
    {
        for(m=i=0;i<n;++i)in(f[i][0]),m+=f[i][0];
        if(m<=k)puts("-1");
        else
        {
            ST();
            l=1,r=n;
            while(l<=r)
            {
                m=(l+r)>>1;
                if(ok(n/m,m))r=m-1,ans=m;
                else l=m+1;
            }
            printf("%d\n",ans);
        }
    }
    return 0;
}

代码(暴力):
#include <cstdio>
using namespace std;
const int mm=200005;
int a[mm],mx[mm];
int i,l,r,m,n,k,ans,sum,tmp;
void pre(int k)
{
    int i,j,v;
    for(i=1;i<=n/k;++i)
        for(j=(v=i*k-k)+1,mx[v]=-1;j<v+k+1;++j)
            if(a[j]>mx[v])mx[v]=a[j];
}
void in(int &a)
{
    char c;
    while((c=getchar())<'0'||c>'9');
    for(a=0;c>='0'&&c<='9';c=getchar())a=a*10+c-'0';
}
int main()
{
    while(scanf("%d%d",&n,&k),n>=0&&k>=0)
    {
        for(sum=0,i=1;i<=n;++i)in(a[i]),sum+=a[i];
        if(sum<=k)puts("-1");
        else
        {
            l=1,r=n;
            while(l<=r)
            {
                m=(l+r)>>1;
                pre(m);
                for(tmp=sum=i=0;i+m<=n;i+=m)
                {
                    sum+=mx[i];
                    ++tmp;
                    if(sum>k)break;
                }
                if(sum<=k)r=m-1;
                else l=m+1,ans=tmp;
            }
            printf("%d\n",ans);
        }
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 4
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 4
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值